/*XPTUNES_I18N*/
/*global addEventListener: false, blur: false, clearInterval: false, clearTimeout: false, document: false, history: false, Image: false,  setInterval: false, setTimeout: false, XMLHttpRequest: false */
var GenrePageFlow = [XPTUNES_CONFIG_GENRE_PAGEFLOW];
var pageHistory = [];
var browseTimer;
var currentHash = location.hash;
var hashPrefix = '#_';
var newPageCount = 0;
var forceAsynchron = false; //set to true if you use app with track info -> else JR blocks your request
var refreshInterval = 1000;
var poolingStarted = false;
var playingNowId = '';
var playingNowPos = '';
var oldFileId = '';
var oldFileRate = '';
var args = '';
var searchFieldValue = '';
started = false;
var loginSeed;
var executeCallUrl = true;
var constPlayerPlay = '[XPTUNES_I18N_PLAYER_PLAY]';
var constFileAdd = '[XPTUNES_I18N_FILE_ADD]';
var constSmartlistRefresh = '[XPTUNES_I18N_REFRESH]';
var constShuffle = '[XPTUNES_I18N_SHUFFLE]';
var constDeleteAll = '[XPTUNES_I18N_DELETE ALL]';	
var constPlayOrAdd = '[XPTUNES_I18N_PLAYORADD]';
var constPlayerStop = '[XPTUNES_I18N_PLAYER_STOP]';
var constPlayerPause = '[XPTUNES_I18N_PLAYER_PAUSE]';
var constPlayerPrevious = '[XPTUNES_I18N_PLAYER_PREVIOUS]';
var constPlayerNext = '[XPTUNES_I18N_PLAYER_NEXT]';
var constPlayerMute = '[XPTUNES_I18N_PLAYER_MUTE]';
var constPlayerVolUp = '[XPTUNES_I18N_PLAYER_VOLUME_UP_SHORT]';
var constPlayerVolDown = '[XPTUNES_I18N_PLAYER_VOLUME_DOWN_SHORT]';
var constFileDelete = '[XPTUNES_I18N_FILE_DELETE]';
var constEmptyQueue = '[XPTUNES_I18N_EMPTYQUEUE]';
var constEnterSearch = '[XPTUNES_I18N_ENTER_SEARCH_HERE]';
var constClickHere = '[XPTUNES_I18N_CLICK HERE...]';
var constLoading = '[XPTUNES_I18N_LOADING]';
var constNothingFound = '[XPTUNES_I18N_NOTHING FOUND]';
var constSearch = '[XPTUNES_I18N_SEARCH]';
var constNetworkError = '[XPTUNES_I18N_NETWORK ERROR]';
var constFileNotFound = '[XPTUNES_I18N_FILE NOT FOUND]';
var constNothingToPlay = '[XPTUNES_I18N_NOTHING_TO_PLAY]';
var constError = '[XPTUNES_I18N_ERROR]';

/*********************** global helpers ******************************/
function $(id) { return document.getElementById(id); }

function form_input_is_numeric(input) { 
	return !isNaN(input);  
}

/************************************ search helpers *********************************************************/
function focusSearchField() {
	var searchField = $('searchField');
	if (searchField) {
		if ((searchField.value  == constSearch ) || (searchField.value  == constEnterSearch )) {
			searchFieldValue = '';
			searchField.value = '';
		}
		searchField.focus();
	}
}

/***********************************read page values***********************************************************/	
function readPageValues() {
	var pageId = '';
	var index = pageHistory.length - 1;
	if (index >= 0) {
		pageId = pageHistory[index];
	}
	var divAttr = $('divAttr' + pageId );
	try{
		if (divAttr) {
			this.page = divAttr.getAttribute('page');
			this.curPageTmp = divAttr.getAttribute('curpagetmp');
			this.subpage = divAttr.getAttribute('subpage');
			this.curPage = divAttr.getAttribute('curpage');
			this.source = divAttr.getAttribute('source');
			this.mediatype = divAttr.getAttribute('mediatype');
			this.searchtype = divAttr.getAttribute('searchtype');
			this.sourceobj = divAttr.getAttribute('sourceobj');
			this.targetobj = divAttr.getAttribute('targetobj');
			this.subvalue = divAttr.getAttribute('subvalue');
			this.searchvalue = divAttr.getAttribute('searchvalue');	 
			this.sort = divAttr.getAttribute('sort');	 
			this.showmaxitems = divAttr.getAttribute('showmaxitems');	
			this.itemsfound = divAttr.getAttribute('itemsfound');
			this.subtype = divAttr.getAttribute('subtype');
			this.searchformula = divAttr.getAttribute('searchformula');
		}
	}catch(ex) {}
}
function saveSearchValues(searchfield,sourceobj, searchOption, targetobj) {
	var divAttr = $('divAttrSummarySearch');
	try{
		if (divAttr) {
			this.searchfield = searchfield;
			this.sourceobj = sourceobj;
			this.searchOption = searchOption;
			this.targetobj = targetobj;
		}
	}catch(ex) {}
}
function loadSearchValues() {
	var sourceobj, searchOption, targetobj, divAttr;
	divAttr = $('divAttrSummarySearch');
	try{
		if (divAttr) {
			if (this.searchfield.length > 0) {
				setSearchField(decodeURIComponent(this.searchfield));
			}	
			if (this.sourceobj.length > 0) {
				sourceobj = $('sourceobj');
				if (sourceobj) {
					sourceobj.value = this.sourceobj;
				}
			}	
			if (this.searchOption.length > 0) {
				searchOption = $('searchOption');
				if (searchOption) {
					searchOption.value = this.searchOption;
				}
			}	
			if (this.targetobj.length > 0) {
				targetobj = $('targetobj');
				if (targetobj) {
					targetobj.value = this.targetobj;
				}
			}	
		}
	}catch(ex) {}
}
function readMediaType() {
	var pageId = '';
	var index = pageHistory.length - 1;
	if (index >= 0) {
		pageId = pageHistory[index];
	}
	var divAttr = $('divAttr' + pageId );

	try{
		if (divAttr) {
			this.mediatype = divAttr.getAttribute('mediatype');
		}
	} catch(ex) {}
	return this.mediatype;
}				
/***********************************LOGIN***********************************************************/

function redirect(page) {
	top.location.href = page;
}

/**************************************MAIN JAVASCRIPT**********************************************/
function setRefreshArgs(commands) {
// 	called from html onload
//	sets arguments for reloading
	args = commands;
}

function defaultMsg_Text(text) {
	var msg_text, msg_area;
	try{
		msg_text = $('msg_text');	
		msg_area = $('msg_area');	
		if (msg_text) {
			msg_text.innerHTML = '';
			msg_area.style.backgroundColor = 'transparent';
		}
	}catch(ex) {}	
}
function updateMsgCommand(text,type) {
	var msg_command = $('msg_text');	
	var msg_area = $('msg_area');	
	if (typeof(text) == 'string' && text != 'initvalues') {
		if (text.length === 0) {
			text = '';
		}
		if (msg_command) {
			msg_command.innerHTML=text;
		}
		if (msg_area) {
			msg_area.style.backgroundColor = 'transparent';
		}
	}
}
function updateMsgText(from,text,type) {
	var timer = 1500;
	var msg_text = $('msg_text');	
	var msg_area = $('msg_area');	
	if (msg_area) {
		tmpMsgtext = 'a';
		if (type == 'error' || type == 'hint') {
		//		tmpMsgtext='';
			if (type == 'error') {
				msg_area.style.backgroundColor = '#ed1c24';	
			}else{
				msg_area.style.backgroundColor = '#4A6C9B';	
			}
			if (from == 'page' && !this.browseTimer) {
				tmpMsgtext = msg_text.innerHTML;
			}else{
				window.clearTimeout(this.browseTimer);
				try{
					delete this.browseTimer;
				}catch(err) {}				
			}
		//		if (from =='page' && type=='hint') {
			if (from == 'page' && text == constLoading ) {
				timer = 5000;
			}
			this.browseTimer = setTimeout(defaultMsg_Text, timer,tmpMsgtext);
		}
	}	
	if (msg_text) {
		if (typeof this.browseTimer == 'number' && type != 'error' && type != 'hint') {
			msg_area.style.backgroundColor = '#4A6C9B';
			msg_area.style.color = '#ffffff';
		}
		if (text.length === 0) {
			text = 'home';
		}

		msg_text.innerHTML=text;
		if (from != 'page') {
			setTimeout(defaultMsg_Text, 1500);
		}
	}
}
function setSearchField(val) {
	var searchField, range, len;
	searchField = $('searchField');
	if (searchField) {
		searchField.focus();
		if ((searchField.value  == constSearch ) || (searchField.value  == constEnterSearch )) { // nur bei zurck Wert neu setzen toDo !!!
			searchField.value = unescape(val); 
			if (document.selection && document.selection.createRange) {
				range = searchField.createTextRange();
				len = searchField.value.length || 0;
				range.moveStart('character', len);
				range.select();
			}
		}
	}
}

function markLink(obj) {
	var child, parentNode;
	parentNode = obj.parentNode;
	for (child = parentNode.firstChild; child; child = child.nextSibling) {
			child.className = '';
	}
	obj.className = 'active';
}
/********************************** page flow ************/
function addPageToHistory(page) {
	if (page != pageHistory[pageHistory.length - 1]) {
		pageHistory.push(page);
	}
}
function insertPages(nodes) {
	var pagename, i, child;
	try{
		pagename = nodes[0].getAttribute('pagename');
	}catch(e) {}

	for (i = 0; i < nodes.length; ++i) {
		child = nodes[i];

		if (child.nodeType == 1) {
			if (!child.id) {
				child.id = '__' + (++newPageCount) + '__';
			}
			var clone = $(child.id);
			if (clone) {
				// Abschnitt bereits vorhanden -> ersetzen
				document.body.appendChild(child);
				clone.parentNode.replaceChild(child, clone);
			}else{
				document.body.appendChild(child);
			}
			--i;
		}
	}

	if (typeof(pagename) == 'string') {
		var divAttr, obj, ref, searchString, index;
		var pageId = '';
		
		addPageToHistory(pagename);
		//mark navigation entrie as active
		if (pagename.toLowerCase() == 'queue') {
			obj = $('navqueue');
			markLink(obj);
		}else if (pagename.toLowerCase() == 'search') {
			obj = $('navsearch');
			markLink(obj);
		}else if (pagename.toLowerCase() == 'summarysearch') {
			loadSearchValues();
		}else if (pagename.toLowerCase() == 'files') {
			ref = $('refresh');
			if (ref) {
				index = pageHistory.length - 1;
				if (index >= 0) {
					pageId = pageHistory[index];
				}
				
				divAttr = $('divAttr' + pageId);
				try{
					if (divAttr) {
						this.subtype = divAttr.getAttribute('subtype');
					}
				}catch(ex) {}

				if (this.subtype != 'smartlist') {
					ref.style.display = 'none';
				}else{
					ref.style.display = 'block';
				}	
			}
		}
		
		index = pageHistory.length - 1;
		if (index >= 0) {
			pageId = pageHistory[index];
		}

		divAttr = $('divAttr' + pageId);
			
		try{
			if (divAttr) {
				this.subvalue = decodeURIComponent(divAttr.getAttribute('subvalue'));
				if (this.subvalue.length > 0) {
					searchString = this.subvalue.split(']=[');
					//test 15.03.2012
					//	setSearchField(searchString[1].substr(0, searchString[1].length - 1));
					//Bei Zurck muss das vorhandene searchfield wieder in die globale var bertragen werden
					searchFieldValue = searchString[1].substr(0, searchString[1].length - 1);
					setSearchField(searchFieldValue);
				}
			}
		}catch(em) {}
	}
}
function callUrl(href,showLoadMsg) {	
		href = encodeURIComponent(href);
		if (this.browseTimer) {
			window.clearTimeout(this.browseTimer);
		}
		req = new XMLHttpRequest();
		if (showLoadMsg===true) {
			updateMsgText('page',constLoading,'hint');
		}
		req.onreadystatechange = function() {
			if (req.readyState != 4 )  {return; }

			if (req.readyState == 4) {
				if (req.status == 200)  {
					var frag = document.createElement('div');

					if (req.responseText.indexOf('itemsfound="0"')>0) {
						updateMsgCommand('','');

						if (req.responseText.toLowerCase().indexOf('pagename="queue"')>0) {
							callUrl('blank.html');
						}else{
							updateMsgText('page',constNothingFound,'error');
						}
					}else{
						frag.innerHTML = req.responseText;
						insertPages(frag.childNodes);
						updateMsgCommand('','');
					}
				}else if (req.status === 0) {	
					// Handle error, e.g. Display error message on page
					updateMsgText('page',constNetworkError,'error');
					return false;
				}else if (req.status === 404) {	
					// file error
					updateMsgText('page',constFileNotFound,'error');
					return false;
				}else{	
					// Handle error
					updateMsgText('page',constError,'error');
					return false;
				}		
			}
        };
	    req.open('GET', href, true);	
		req.send(null);
	}
function changeStatusbar(str) {
	top.window.defaultStatus=str;
}	
function checkPlayerState(str) {
	var playerStatus;
//check playerstate
	switch (str) {
		case 'stopped':
			playerStatus = 'stopped';
			if (typeof stopTicker == 'function') {
				stopTicker('');
			}
			if (typeof top.content.stopSlider == 'function') {
				top.content.stopSlider('');
			}
			break;
		case 'paused':
			playerStatus = 'paused';
			if (typeof pauseTicker == 'function') {
				pauseTicker();
			}
			if (typeof top.content.pauseSliderTimer == 'function') {
				top.content.pauseSliderTimer('');
			}
			break;
		case 'playing':
			playerStatus = 'playing';	
			break;
	}
	changeStatusbar(playerStatus);
}
function setNewPlayerValues(jsonObj) {
	var hasInnerText;
	var fposition;
	var fposition2;
	var fduration;
	var fduration2;
		
	try{
		hasInnerText = (document.getElementsByTagName('body')[0].innerText !== undefined) ? true : false;
		fposition = $('position');
		fposition2 = $('position2');
		fduration = $('duration');
		fduration2 = $('duration2');
	}catch(err) {}	
	
	this.curPNPos = jsonObj.PNPos;
		
	if (fposition) {
		if (!hasInnerText) {
			fposition.textContent = jsonObj.Position;
		}else{
			fposition.innerText  = jsonObj.Position;
		}
	}
	if (fposition2) {
		if (!hasInnerText) {
			fposition2.textContent = jsonObj.Position2;
		 }else{
			fposition2.innerText  = jsonObj.Position2;
		}
	}
	if (fduration) {
		if (!hasInnerText) {
			fduration.textContent =  jsonObj.Duration;
		}else{
			fduration.innerText  =  jsonObj.Duration;
		}
	}
	if (fduration2) {
		if (!hasInnerText) {
			fduration2.textContent = jsonObj.Duration2;
		}else{
			fduration2.innerText= jsonObj.Duration2;
		}
	}
		
	if (jsonObj.PlayerState) {
		checkPlayerState(jsonObj.PlayerState);
	}
}

/*********************** page history ******************************/
function clearPageHistory() {
	pageHistory.splice(1, pageHistory.length);
	//init search vars
	this.searchfield = '';
	this.sourceobj = '';
	this.searchOption = '';
	this.targetobj = '';
}
function showPageBack(page) {
	var url, subUrl, divAttr;
	divAttr = $('divAttr'+page);

	try{
		if (divAttr) {
			pagename = divAttr.getAttribute('page');

			if (typeof(pagename) == 'string') { 
				if (pagename.indexOf('Summary') < 0 && pagename !== 'Playlists.html') {
					pagename = 'Summary'+pagename ;
				}
				readPageValues(); 

				subUrl = 'source=' + this.source + '&mediatype=' + this.mediatype + '&searchtype=' + this.searchtype + '&sourceobj=' + this.sourceobj + '&targetobj=' + this.targetobj + '&value=' + this.searchvalue + '&sort=' + this.sort + '&subvalue=' + this.subvalue + '&searchformula=' + this.searchformula;
				url = pagename +'?' + subUrl + '&showpage='+ this.curPageTmp;	
				if (typeof(maxitems) == 'number') {
					url = url + '&showmaxitems=' + maxitems;
				}
				if (pagename.toLowerCase() == 'summarysearch') {
					callUrl(pagename +'.html');
				}else{
					callUrl(url);
				}
			}else{
				callUrl(page +'.html');
				//if (page.toLowerCase()=='summarysearch') {
				//	loadSearchValues();
				//}
			}
		}else{
			// no attrDiv found -> call pagename
			callUrl(page +'.html');
		}
	}catch(ex) {}
}
function pageBack() {
		var index = pageHistory.length - 1;
		if (index > 0) {
			pageHistory.splice(index,1);
			var pagename = pageHistory[pageHistory.length - 1]; 
			
			if (pagename) {
				if (pagename == 'home') {
					pageHistory.splice(0, pageHistory.length);
				}
					showPageBack(pagename);
			}
		}	
}

/***********************************LAYOUT***********************************************************/

function setCSSPlayingNow (jsonObj) {
	var posFound, tcurId, tcurPNPos, ulQueue, tabs, i;
	if (jsonObj) {
		try{	
			if (args) {
				posFound = args.indexOf('markpnfile');
				if (posFound != - 1) {
					tcurId = jsonObj.Id;
					tcurPNPos = jsonObj.PNPos;
					//get playingNow/queue UL
					ulQueue = $('Queue');
					if (ulQueue) {
						if (!(this.curFileId == tcurId && this.curPNPos == tcurPNPos)) {	
							tabs = ulQueue.getElementsByTagName('li');
							for( i = 0; i < tabs.length; i++) {
								if (tabs[i].id == tcurPNPos) {
									tabs[i].setAttribute('playingnow','true');
								}else{
									tabs[i].removeAttribute('playingnow');
									tabs[i].removeAttribute('selected');
								}
								// Important for IE7 update Playing now
								if (tabs[i].className) {
									tabs[i].className = tabs[i].className;
								}
							}
							
							this.playingNowId = tcurId;
							this.playingNowPos = tcurPNPos;
							try{
								document.recalc();
							}catch(xy) {}
						}
					}
				}
			}
		}catch(x) {}			
	}
}
function clearTrackValues() {
	var hasInnerText = (document.getElementsByTagName('body')[0].innerText !== undefined) ? true : false;
	this.curFileId = '';
	this.curFileRate = '';
	this.curPNPos = '';
	this.curArtist = '';
	this.curName = '';
	this.playingNowId = - 1;
	this.playingNowPos = - 1;
	var fartist = $('idArtist');
	var ftitle = $('idTitle');
	var fgenre = $('idGenre');
	var fyear = $('idYear');
		
	var falbum = $('idAlbum');
	var fcoverFull = $('idCoverFull');
	var frating = $('idRating');
	var fduration = $('duration');
	var fduration2 = $('duration2');
	var fposition = $('position');
	var fposition2 = $('position2');
	
	if (fcoverFull) {
		try{	
			if (fcoverFull.src) {		
				fcoverFull.src = 'control.cgi?command=getcoverbyid&value=-1&subvalue=medium' ;
				fcoverFull.setAttribute('fileId','');
			}
		}catch(pic) {}
	}
	if (fartist) {
		if (!hasInnerText) {
			fartist.textContent = '';
		}else{
			fartist.innerText = '';
		}
		fartist.setAttribute('fileId','');
	}
	if (ftitle) {
		if (!hasInnerText) {
			ftitle.textContent = '';
		}else{
			ftitle.innerText = '';
		}
		ftitle.setAttribute('fileId','');
	}
	if (fgenre) {
		if (!hasInnerText) {
			fgenre.textContent = '';
		}else{
			fgenre.innerText = '';
		}
		fgenre.setAttribute('fileId','');
	}
	if (fyear) {
		if (!hasInnerText) {
			fyear.textContent = '';
		}else{
			fyear.innerText = '';
		}
		fyear.setAttribute('fileId','');
	}
	if (falbum) {
		if (!hasInnerText) {
			falbum.textContent = '';
		 }else{
			falbum.innerText = '';
		}
		falbum.setAttribute('fileId','');
	}
	if (frating) {
		frating.innerHTML = '';
	}
	if (fposition) {
		if (!hasInnerText) {
			fposition.textContent = '0';
		}else{
			fposition.innerText  = '0';
		}
	}
	if (fposition2) {
		if (!hasInnerText) {
			fposition2.textContent = '00:00';
		 }else{
			fposition2.innerText  = '00:00';
		}
	}
	if (fduration) {
		if (!hasInnerText) {
			fduration.textContent = '0';
		}else{
			fduration.innerText  = '0';
		}
	}
	if (fduration2) {
		if (!hasInnerText) {
			fduration2.textContent = '00:00';
		}else{
			fduration2.innerText= '00:00';
		}
	}
}		

/***********************************Zone Layout*********************************************************/
function zoneChange(jsonObj) {
	var child;
	if (jsonObj[0]) {
		var ZonesElem = $('Zones');
		if (ZonesElem) {
			for (child = ZonesElem.firstChild; child; child = child.nextSibling) {
				if (child.nodeType == 1) {
					child.removeAttribute('activeZone');
				}
			}
			var newelem = $(jsonObj[0].value);
			newelem.setAttribute('activeZone','');
		}
	}
}
/***********************************RATING Layout*********************************************************/
function setNewRating(fileId,ratingValue,ratingId) {
	var i, ratHtml;
	ratHtml = '';
	if (fileId != '0') {
		ratHtml = '<ul class="starrating">';
		this.curFileRate = ratingValue;
		
		for(i = 1; i <= 5; i++) {
			ratHtml = ratHtml +'<li><a href="#" onclick="setRatingByFileId('+ fileId +','+ i + ');" title="'+ i +' out of 5 stars" class="star'+i+'">';
			
			if (i > ratingValue) {
				ratHtml = ratHtml +'<div class="star0">';
			}else{
				ratHtml = ratHtml +'<div class="star1">';
			}
			
			ratHtml = ratHtml +'</div></a></li>';
		}
		ratHtml = ratHtml +'</ul>';
	}
	return ratHtml;
}
function setNewTrackValues(jsonObj) {
	var hasInnerText = (document.getElementsByTagName('body')[0].innerText !== undefined) ? true : false;
	var fartist = $('idArtist');
	var ftitle = $('idTitle');
	var fgenre = $('idGenre');
	var fyear = $('idYear');
	var falbum = $('idAlbum');
	var fcoverFull = $('idCoverFull');
	var frating = $('idRating');
	var fduration2 = $('idDuration');

	document.curFileId=jsonObj.Id;
	this.curFileId=jsonObj.Id;
	if (typeof jsonObj== 'object') {
		if (fcoverFull) {
			try{	
				if (fcoverFull.src) {		
					fcoverFull.src = 'control.cgi?command=getcoverbyid&value=' + jsonObj.Id +'&subvalue=large&mediatype=' +jsonObj.MediaType;
					fcoverFull.setAttribute('fileId',jsonObj.Id);
				}
			}catch(pic) {}
		}
		if (fartist) {
			if (!hasInnerText) {
				fartist.textContent = decodeURIComponent(jsonObj.Artist);
			}else{
				fartist.innerText = decodeURIComponent(jsonObj.Artist);
			}
			fartist.setAttribute('fileId',jsonObj.Id);
		}
		if (falbum) {
			if (!hasInnerText) {
				falbum.textContent = decodeURIComponent(jsonObj.Album);
			}else{
				falbum.innerText = decodeURIComponent(jsonObj.Album);
			}
			falbum.setAttribute('fileId',jsonObj.Id);
		}
		if (ftitle) {
			if (!hasInnerText) {
				ftitle.textContent = decodeURIComponent(jsonObj.Name);
			}else{
				ftitle.innerText = decodeURIComponent(jsonObj.Name);
			}
			ftitle.setAttribute('fileId',jsonObj.Id);
		}
		if (fgenre) {
			if (!hasInnerText) {
				fgenre.textContent = decodeURIComponent(jsonObj.Genre);
			}else{
				fgenre.innerText = decodeURIComponent(jsonObj.Genre);
			}
			fgenre.setAttribute('fileId',jsonObj.Id);
		}
		if (fyear) {
			if (!hasInnerText) {
				fyear.textContent = jsonObj.Year;
			}else{
				fyear.innerText = jsonObj.Year;
			}
			fyear.setAttribute('fileId',jsonObj.Id);
		}
		if (frating) {
			frating.innerHTML = setNewRating(jsonObj.Id,jsonObj.Rating,frating);
		}		
		if (fduration2) {
			if (!hasInnerText) {
				fduration2.textContent = jsonObj.Duration2;
			}else{
				fduration2.innerText = jsonObj.Duration2;
			}
		}
	}else{
		clearTrackValues();
	}
}
function checkReloadFrame(jsonObj, refreshtype) {
//	check if a frame must be reloaded
	var reload = false;
	var posFound = args.indexOf(refreshtype);
	if (posFound != - 1) {
		if (refreshtype == 'trackchange') {
			if (this.curFileId != jsonObj.Id) {
				reload = false;
				setNewTrackValues(jsonObj);
			}	
		}else if (refreshtype == 'filechange') {
			if (this.curFileId == jsonObj.Id) {
				if (this.curFileRate != jsonObj.Rating) {
					reload = false;
					setNewTrackValues(jsonObj);
				}
			}
		}else if (refreshtype == 'updateplaynow') {
			reload = true;
		}
	}else{
		if (posFound===0 && this.itemsfound == '1') {
			history.back();
		} else if (refreshtype == 'updateplaynow') {
			reload = true;
		}
	}
}
function checkPlayerChange(jsonObj) {
	setCSSPlayingNow(jsonObj);
	setNewPlayerValues(jsonObj);
}
function saveNewFileInfos(jsonObj) {
//save file values to vars 
//first load old values (if present)
	try{
		this.curFileId = jsonObj.Id;
		this.curFileRate = jsonObj.Rating;
		this.curArtist = decodeURIComponent(jsonObj.Artist);
		this.curName = decodeURIComponent(jsonObj.Name);
	}catch(err) {}
}
function checkChangeTrack(jsonObj) {
	checkReloadFrame(jsonObj, 'trackchange');
	saveNewFileInfos(jsonObj);
}
function checkFileChange(jsonObj) {
	checkReloadFrame(jsonObj, 'filechange');
	saveNewFileInfos(jsonObj);
}

/***********************************CONNECTION***********************************************************/
function commandCallback(jsonArr) {	
//callback from xpTunes Server
//response 2. step
//	console.log("xpTunes:" + jsonArr);
	var jsonObjArr, x, responseTyp, val;
	try{
		jsonObjArr = eval('(' + jsonArr + ')');	
		for (x = 0; x < jsonObjArr.length; x+=1) {
			started = true;
			try{
				responseTyp = jsonObjArr[x].response;
				val = jsonObjArr[x].value;
		
				if (responseTyp == 'playerstate') {
					try{
						checkPlayerState(val);
					}catch(a) {}
				}
				else if (responseTyp == 'playerinfo') {
					try{
						checkPlayerChange(val);
					}catch(c) {}
				}
				else if (responseTyp == 'trackinfo') {
					try{
						setCSSPlayingNow(val);
					}catch(e) {}
				}
				else if (responseTyp == 'trackchange') {
					try{
						if (val.length !== 0) {
							checkChangeTrack(val);
						}
					}catch(f) {}
				}
				else if (responseTyp == 'filechange') {
					try{
						checkFileChange(val, 'filechange');
					}catch(g) {}		
				}
				else if (responseTyp == 'updateplaynow') {
					try{
						checkReloadFrame(val, 'updateplaynow');
					}catch(k) {}		
				}
				else if (responseTyp == 'filelist') {
					try{
						return jsonObjArr;
					}catch(l) {}		
				}
				//else if (responseTyp == 'login') {
				//	try{
					//	val = jsonObjArr[x].value;
					//	checkLogin(val);
				//	}catch(j) {}		
				//}
				else if (responseTyp == 'redirect') {
					try{
						val = jsonObjArr[x].value;
						redirect(val);
					}catch(n) {}		
				}
				else if (responseTyp == 'loginseed') {
					try{
						val = jsonObjArr[x].value;
						loginSeed=val;
					}catch(o) {}		
				}
				else if (responseTyp == 'zonechange') {
					try{
						zoneChange(jsonObjArr);
					}catch(p) {}		
				}
				else if (responseTyp == 'smartlistrefresh') {
					try{
					}catch(q) {}		
				}
				else if (responseTyp == 'error') {
					try{
						if (val == 'file error') {
							updateMsgText('page',constFileNotFound,'error');
						} else if (val == 'play error') {
							updateMsgText('page',constNothingToPlay,'error');
						}
					} catch (qs) {}		
				}
			}catch(z) {} /*need this catch for error-handling with ie7*/
		}
	}catch(ax) {}
	started = false;
}

function command(action, value, subvalue, synchron) {
// 	sends a synchron/asynchron command to xpTunes server
//	request
	var url = '';
	http_request = false;
	value = encodeURIComponent(value);

	/* prevent cache with new Date().valueOf() */
	if ( typeof(subvalue) !== null && typeof(subvalue) !== 'undefined') {
		if ( action == 'playSearchFiles' || action == 'SmartlistRefresh' || action == 'addSearchFiles' || action == 'delFileFromPlayingNowByPos' || action == 'getSimilarTracksByID' || action == 'getSimilarArtistsByID'  || action == 'addById' || action == 'playById' || action == 'playOrAdd' ) {
			url = value + '&preventCache=' + new Date().valueOf();	
		} else {
			url = 'control.cgi?command=' + action + '&value=' + value + '&subvalue=' + subvalue +'&preventCache=' + new Date().valueOf();
		}
	}else{
		url = 'control.cgi?command=' + action + '&value=' + value + '&preventCache=' + new Date().valueOf();
	}
	
	url += '&subsid=2';
    if (window.XMLHttpRequest) { // Mozilla,  Safari, IE7...
		http_request = new XMLHttpRequest();
        if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
        }
    }else if (window.ActiveXObject) { // IE6
        try {
            http_request = new ActiveXObject('Msxml2.XMLHTTP');
        }catch (e) {
			try {
				http_request = new ActiveXObject('Microsoft.XMLHTTP');
            } catch (c) {}
        }
    } 
    /*    if (!http_request) {
         alert('Ende :( Kann keine XMLHTTP-Instanz erzeugen');
	return false;
	}*/

    var ret;
	
	if (http_request) {
		if (synchron && !forceAsynchron) {
			action2MsgText(action);
			http_request.open('GET', url, false);
			http_request.onreadystatechange = function () {
				if (http_request.readyState == 4) {
					if (http_request.status == 200) {
						var ret = commandCallback(http_request.responseText);
						return ret;
					}
				}
			};
		} else {
			http_request.onreadystatechange = function () {
				if (http_request.readyState == 4) {
					if (http_request.status == 200) {
						var ret = commandCallback(http_request.responseText);
						return ret;
					}
				}
			};
			http_request.open('GET', url, true);
			action2MsgText(action);

		}
	}
	http_request.send(null);
    return ret;
}
function action2MsgText(action) {

	switch (action.toLowerCase()) {
		case 'load':
			updateMsgText('page',constLoading,'hint');
			break;
		case 'play':
		case 'playfilebypos':
		case 'playbyid':
		case 'playsearchfiles':
			updateMsgText('page',constPlayerPlay,'hint');
			break;
		case 'addbyid':
		case 'addsearchfiles':
			updateMsgText('page',constFileAdd,'hint');
			break;	
		case 'smartlistrefresh':
			updateMsgText('page',constSmartlistRefresh,'hint');
			break;		
		case 'reshuffleplayingnow':
			updateMsgText('page',constShuffle,'hint');
			break;	
		case 'delplayingnow':
			updateMsgText('page',constDeleteAll,'hint');
			break;		
		case 'playoradd':
			updateMsgText('page',constPlayOrAdd,'hint');
			break;	
		case 'stop':
			updateMsgText('page',constPlayerStop,'hint');
			break;		
		case 'pause':
			updateMsgText('page',constPlayerPause,'hint');
			break;			
		case 'previous':
			updateMsgText('page',constPlayerPrevious,'hint');
			break;
		case 'next':
			updateMsgText('page',constPlayerNext,'hint');
			break;
		case 'voldown':
			updateMsgText('page',constPlayerVolDown,'hint');
			break;
		case 'mute':
			updateMsgText('page',constPlayerMute,'hint');
			break;
		case 'volup':
			updateMsgText('page',constPlayerVolUp,'hint');
			break;	
		case 'delfilefromplayingnowbypos':
			updateMsgText('page',constFileDelete,'hint');
			break;	
	}
}				
function pooling() {
//	simple pooling -> response to commandCallback
//	pooling 3. step
   pool_request = false;
	/* prevent cache with new Date().valueOf() */
	var url = 'control.cgi?command=update&preventCache=' + new Date().valueOf();
	url += '&subsid=2';
	
    if (window.XMLHttpRequest) { // Mozilla, Safari,...
        pool_request = new XMLHttpRequest();
        if (pool_request.overrideMimeType) {
            pool_request.overrideMimeType('text/xml');
        }
    }else if (window.ActiveXObject) { // IE
        try {
            pool_request = new ActiveXObject('Msxml2.XMLHTTP');
        } catch (a) {
            try {
                pool_request = new ActiveXObject('Microsoft.XMLHTTP');
            } catch (b) {}
        }
    }
	
	pool_request.onreadystatechange = function () {
		if (pool_request.readyState == 4) {
			if (pool_request.status == 200) {
				var ret = commandCallback(pool_request.responseText);
				return ret;
			}
		}
	};
		
	if (pool_request) {
		pool_request.open('GET', url, true);
        pool_request.send(null);
	}
}


function emulateSetInterval() {
//	sends a request to xpTunes server all x ms (refreshInterval default =2500)  
//	pooling 2. step
	pooling();
	this.poolTimer = setTimeout('emulateSetInterval()', refreshInterval);
}

function stopPooling() {
	window.clearTimeout(this.poolTimer);
	try{
		delete this.poolTimer;
	}catch(e) {}
}
function startPooling(commands, forceNewSession) {
//	request values from server to update or refresh site(tick) (onLoad-Event in html)
//	some vars are saved in this section
//	pooling 1. step
	forceNewSession = false;

	if (forceNewSession) {
		poolingStarted = false;
	}
	//fill global values to check later if site should be refreshed
	if (commands.length !== 0) {
		args = commands;
	}
	
	if (!(poolingStarted)) {
		//check if onLoad is a Reload or a new Load
		try{
			emulateSetInterval();
			poolingStarted = true;
		}catch(q) {}
	}
}
/***********************************RATING Command*********************************************************/
function setRatingByFileId(fileID, rate) {
	oldFileId = fileID;
	command('setRatingByFileId', fileID, rate, false);

	var frating = $('idRating');
	if (frating) {
		if (rate == this.curFileRate) {
			rate = rate - 1;
		}
		frating.innerHTML = setNewRating(fileID,rate,frating);
	}
}
/***********************************Zone Commands*********************************************************/
function setActiveZone(ZoneID) {
	command('setActiveZone', ZoneID,'', true);
	callUrl('Queue.html');
}
function syncAllZones() {
	command('syncAllZones', '','', true);
	callUrl('zones.html');
}
function playAllZones() {
	command('playAllZones', '','', true);
	callUrl('zones.html');
}
function pauseAllZones() {
	command('pauseAllZones', '','', true);
	callUrl('zones.html');
}
function stopAllZones() {
	command('stopAllZones', '','', true);
	callUrl('zones.html');
}
function syncZones(destZone) {
	command('syncZones', destZone,'', true);
	callUrl('zones.html');
}
function zoneVoldown(zoneId,vol) {
	command('zoneVoldown', zoneId,'5', true);
}
function zoneVolup(zoneId,vol) {
	command('zoneVolup', zoneId,'5', true);
}
function zoneMuteToggle(zoneId) {
	command('zoneMuteToggle', zoneId,'', true);
}
/**************************************SEARCH***********************************************************/

function clickclear(thisfield, defaulttext) {
	if (thisfield.value == defaulttext) {
		searchFieldValue = ''; //globale Var zurcksetzen
		thisfield.value = '';
	}
	thisfield.style.color = '#000000'; 
}
function clickrecall(thisfield, defaulttext) {
	if (thisfield.value === '') {
		thisfield.value = defaulttext;
	}
	thisfield.style.color = '#888888'; 
}
function activate_search(el) {
//set searchfield to space
	if (el.defaultValue==el.value) {
		el.value = '';
	}
}
function clear_search(el) {
//set searchfields to space
	var doc = this.document;
	
	if (doc) {
		if (doc.searchall.searchfield.value) {
			doc.searchall.searchfield.value = '';
		}
		if (doc.searchartist.searchfield.value) {
			doc.searchartist.searchfield.value = '';
		}
		if (doc.searchname.searchfield.value) {
			doc.searchname.searchfield.value = '';
		}
		if (doc.searchalbum.searchfield.value) {
			doc.searchalbum.searchfield.value = '';
		}
	}
}
function doSearch() {
//search from inputfield 
	var url;
	searchFieldValue = encodeURIComponent($('searchField').value); //11.07.2011 aktiviert wegen +44
	var subvalue = searchFieldValue;
	var sourceobj = $('sourceobj').value;
	var searchOption = $('searchOption').value;
	var targetobj = $('targetobj').value;

	saveSearchValues(subvalue,sourceobj, searchOption, targetobj);
	
	var sort = '';
		try{
			if (searchOption) {
				if (searchOption == 'starts') {
					subvalue = '['+ subvalue +'%22';
				}
			}
			if (sourceobj) {
				if (sourceobj == 'all') {
					sort = '';
				}else{
					subvalue = '['+sourceobj+']=' + subvalue;
					sort = '['+sourceobj+']';
				}
			}

		}catch(e) {}

		if (subvalue.length > 0) {
			if (subvalue == constEnterSearch) {
				subvalue = '';
			}

			if (targetobj == 'album') {
				url = 'SummarySearchAlbum.html?source=library&mediatype=audio&sourceobj='+ sourceobj +'&targetobj=album&searchtype=name&resulttype=grouped&subvalue=' + subvalue +'&sort=' + sort;
			}else{
				url = 'Files.html?source=library&mediatype=audio&sourceobj='+ sourceobj +'&targetobj=files&searchtype=name&subvalue=' + subvalue + '&sort=' +sort;
			}
			if (typeof(maxitems) == 'number') {
				url = url + '&showmaxitems=' + maxitems;
			}
			callUrl(url);
		}
}

function doSearchQueue(targetobj,searchValue) {
//search from inputfield 
	searchFieldValue = searchValue;
	readPageValues();
		
	this.searchtype = 'name';
	if (searchValue.length > 0) {
		searchValue = '['+ searchValue +'%22';
	
		try{
			searchValue = '['+ targetobj +']=' + searchValue;
		}catch(e) {}

		if (searchValue == constSearch) {
			searchValue = '';
			searchFieldValue = '';
		}
	}
	this.subvalue=searchValue;
	var subUrl = 'source=playingnow&searchtype='+ this.searchtype +'&subvalue='+ this.subvalue+'&searchformula='+this.subvalue;
	var url = 'Queue.html?' + subUrl;	
	
	callUrl(url);

}
function doSearchArtist(targetobj,searchValue) {
//search from inputfield 
	var url = '';
	var pageId = '';

	searchFieldValue = searchValue;

	var index = pageHistory.length - 1;
	if (index >= 0) {
		pageId = pageHistory[index];
	}
	
	var divAttr =$('divAttr' + pageId);
	readPageValues();
	
	try{
		this.sourceobj = divAttr.getAttribute('sourceobj');
	}catch(e) {
		this.sourceobj = '';
	}

	if (searchValue.length > 0) {
		searchValue = '['+ searchValue +'%22 ~d=t';
		try{
			searchValue = '['+ targetobj +']=' + searchValue;
		}catch(ex) {}

		if (searchValue == constSearch) {
				searchValue = '';
		}
	}

	this.subvalue=searchValue;
	if (searchValue.length > 0) {
		url = 'QueueArtist.html?source=library&searchtype=name&sourceobj=artist&targetobj=files&value=&subvalue='+ this.subvalue+'&searchformula=' +this.searchformula;
	}else{
		url = 'SummaryQueue.html';
	}
	 
	callUrl(url);
}
function doSearch2(targetobj,searchValue) {
//search from inputfield 
	var pageId = '';
	if (searchFieldValue != searchValue) {
		searchFieldValue = searchValue;
		searchValue = encodeURIComponent(searchValue); 	//29.04.2011 wieder aktiviert, wegen +44
	
		var index = pageHistory.length - 1;
		if (index >= 0) {
			pageId = pageHistory[index];
		}
	
		var divAttr =$('divAttr' + pageId);
		readPageValues();
	
		try{
			this.sourceobj = divAttr.getAttribute('sourceobj');
		}catch(e) {
			this.sourceobj = '';
		}
	
		if (searchValue.length > 0) {
			searchValue = '['+ searchValue +'%22';
	
			try{
				searchValue = '['+ targetobj +']=' + searchValue;
			}catch(ex) {}

			if (searchValue == constSearch) {
				searchValue = '';
			}
		}
	
		this.searchtype = 'name';
		if (this.subpage.length > 0) {
			page = this.subpage;
		}else{
			page = this.page;
		}

		this.subvalue=searchValue;
		var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj+'&searchtype='+ this.searchtype +'&value=&showmaxitems='+this.showmaxitems +'&sort='+ this.sort +'&subvalue='+ this.subvalue+'&searchformula='+this.searchformula;
		var url = page +'?' + subUrl;	

		callUrl(url);
	}
}
/***********************************CONTROLS***********************************************************/
function histBack() {
	history.back();
}

function calcPageValues(action,browsestep) {
	var pageId= '';
	var index = pageHistory.length - 1;
	if (index >= 0) {
		pageId = pageHistory[index];
	}
	subPage =$('divAttr' + pageId);
	callUrlFlag = true;
	if (!browsestep) {
		browsestep = 1;
	}
	//fix fast clicks -> same page will else be loaded
	if (!this.curPageTmp) {
		//2. try for chrome & safari
		this.curPageTmp = subPage.getAttribute('curPageTmp');
		
		this.curPage = subPage.getAttribute('curpage');	
		if (!this.curPageTmp) {
			this.curPageTmp = 1;
			subPage.setAttribute('curpagetmp','1');	
			subPage.setAttribute('curpage','1');	
		}
	}else{
		this.curPageTmp = subPage.getAttribute('curpagetmp');	
		this.curPage = subPage.getAttribute('curpage');	
	}
	if (this.curPageTmp===null) {
		this.curPageTmp = 1;
		subPage.setAttribute('curpagetmp','1');	
	}
		
	this.maxPage = subPage.getAttribute('maxpage');
	var newPage;
	if (action == 'back') {
		if ((parseInt(this.curPageTmp,10) - parseInt(browsestep,10)) > 1) {
			newPage = parseInt(this.curPageTmp, 10) - parseInt(browsestep, 10) ;
		}else{
			newPage =1;
		}
	}else{
		if ((parseInt(this.curPageTmp,10) + parseInt(browsestep,10)) < parseInt(this.maxPage,10)) {
			newPage = parseInt(this.curPageTmp, 10) + parseInt(browsestep, 10) ;
		}else{
			newPage =this.maxPage;
		}
	}
		
	this.curPageTmp = newPage;
		
	if (this.curPage == this.curPageTmp || this.maxPage == this.curPageTmp && action == 'next' && !this.curPage || (action == 'back' && this.curPageTmp == 1 && !this.curPage) ) {
		callUrlFlag = false;
	}
	subPage.setAttribute('curpagetmp',newPage);	 
	this.curPageTmp = newPage;
}		
function browsePage(action, browsestep) {
	var showPage=0;
	var page;
	calcPageValues(action,browsestep);
	if (action == 'back') {
		 showPage = parseInt(this.curPage, 10) - parseInt(browsestep, 10);
	}else if (action == 'next') {
		 showPage = parseInt(this.curPage, 10) + parseInt(browsestep, 10);
	}else if (action == 'min') {
		showPage = parseInt(1, 10);
	}else if (action == 'max') {
		showPage = parseInt(this.maxPage, 10);
	}
	
	if (showPage > this.maxPage) {
		showPage = this.maxPage;
	}
	if (showPage <= 0) {
		showPage = 1;
	}
	if (showPage >0 && showPage <= this.maxPage) {
		readPageValues();
					
//targetobj mitgeben fr ggf. weitere Suche				
		var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj	+'&value='+ this.searchvalue +'&showmaxitems='+this.showmaxitems +'&subvalue='+ this.subvalue +'&sort='+ this.sort +'&searchformula='+this.searchformula;

		try{
		if (this.subpage.length > 0) {
			page = this.subpage;
		}else{
			page = this.page;
		}
		}catch(e) {
		page = this.page;
		}
		var url = page +'?' + subUrl + '&showpage='+ showPage;
		callUrl(url);
	}
}		
function callPage(pageNumber, addPage) {

	var showPage=0;
	showPage =  parseInt(pageNumber, 10) + parseInt(addPage, 10);

	if (showPage > this.maxPage) {
		showPage = this.maxPage;
	}
	if (showPage <= 0) {
		showPage = 1;
	}

	if (showPage>0 && showPage<= this.maxPage) {
		readPageValues();
		var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj+'&value='+ this.searchvalue +'&showmaxitems='+this.showmaxitems +'&sort='+ this.sort +'&subvalue='+ this.subvalue;

		var url = this.page+'?' + subUrl + '&showpage='+ showPage;
		callUrl(url);
	}
}
function mousewheelPage(e) { 
	var curPage,maxPage;
	var event=window.event || e; //equalize event object
//	event = window.event;
//	delta = event.wheelDelta;
	var delta=event.detail? event.detail*(-120) : event.wheelDelta;
	
	try{
		curPage = $('currentPage').innerHTML;
		maxPage = $('maxPage').innerHTML;
	}catch(e) {
	
	}
	
	if (curPage && maxPage) {
		if (delta >= 120) {
			if (parseInt(curPage, 10) > 1) {
				newPageNr = parseInt(curPage, 10) - 1;
				$('currentPage').innerHTML = newPageNr;
				browsePageByNr('next',newPageNr);
			}
		} else if (delta <= -120) {
			if (parseInt(maxPage, 10) > parseInt(curPage, 10)) {
				newPageNr = parseInt(curPage, 10)  + 1;
				$('currentPage').innerHTML = newPageNr;
				browsePageByNr('back',newPageNr);
			}
		}
	}
}
function browsePageByNr(action, showPage, wait) {
	var page;
	calcPageValues(action,showPage);
	if (this.browseTimer) {
		window.clearTimeout(this.browseTimer);
	}
	if (!wait) {
		wait = 500;
	}

//	callUrlFlag muss nach calcPageValues stehen
	callUrlFlag=true;
	if (callUrlFlag) {
		executeCallUrl = true;

		if (showPage > 0 && showPage <= this.maxPage) {
			readPageValues();

			// targetobj mitgeben fr ggf. weitere Suche				
			var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj	+'&value='+ this.searchvalue +'&showmaxitems='+this.showmaxitems +'&subvalue='+ this.subvalue +'&sort='+ this.sort +'&searchformula='+this.searchformula;
			try{
				if (this.subpage.length > 0) {
					page = this.subpage;
				}else{
					page = this.page;
				}
			}catch(e) {
				page = this.page;
			}
			var url = page +'?' + subUrl + '&showpage='+ showPage;

			this.browseTimer = this.setTimeout(function () { callUrl(url, true); }, wait);
		}
	}
}
/***********************************ELEMENTS BY NAME******************************************************/
function sFArtist(searchValue) {
// search for Artists
	var url = '';
    if (typeof(this.mediatype) == 'string' && usemediatype ) {
		url = 'artist.html?source=' + this.source + '&mediatype=' + this.mediatype +'&searchtype=name&value=' + searchValue;
	}else{
		url = 'artist.html?source=library&mediatype=audio&searchtype=name&value=' + searchValue;
	}
	callUrl(url);
}
function sFGenre(searchValue) {
// search for Genre
    if (typeof(this.mediatype) == 'string' && usemediatype) {
		parent.content.location.href = 'genre.html?source=' + this.source + '&mediatype=' + this.mediatype +'&searchtype=name&value=' + searchValue;
	}else{
		parent.content.location.href = 'genre.html?source=library&mediatype=audio&searchtype=name&value=' + searchValue;
	}	
}
function sFTitle(searchValue) {
// search forTitle
    if ( typeof(this.mediatype) == 'string' && usemediatype )
    {
	parent.content.location.href = 'title.html?source=' + this.source + '&mediatype=' + this.mediatype +'&searchtype=name&value=' + searchValue;
	}else{
	
	parent.content.location.href = 'title.html?source=library&mediatype=audio&searchtype=name&value=' + searchValue;
	}	
}
/***********************************ELEMENTS BY ID***********************************************************/
function ArtById(fileId, frameName) {
//	files by Artist
	if (fileId.length > 0) {
		var url = 'files.html?source=library&mediatype=audio&sourceobj=artist&searchtype=fileId&value=' + fileId;
		if (typeof(maxitems) == 'number') {
			url = url + '&showmaxitems=' + maxitems;
		}
		callUrl(url);
	}
} 
function SearchById(fileId) {
//	files by Id
	var pageId = '';
	var index = pageHistory.length - 1;
	if (index >= 0) {
		pageId = pageHistory[index];
	}
	var divAttr = $('divAttr' + pageId);
	this.sourceobj = divAttr.getAttribute('sourceobj');
	sourceobj =  this.sourceobj;

	if (fileId.length > 0) {
		var page = 'Files.html';
		var targetobj = 'files';

		if (sourceobj == 'album') {
			page = 'AudioFiles_trackNr.html';
			
		}else if (sourceobj == 'artist') {
			page = 'SummaryAlbum.html';
			targetobj = 'album';

			if (showAlbumPage === false) {
				page = 'Files.html';
				targetobj = 'files';
			}
		}
		var url = page + '?source=library&mediatype=audio&searchtype=fileId&sourceobj='+ sourceobj +'&targetobj='+targetobj+'&value=' + fileId;
		callUrl(url);
	}
} 
/***********************************ELEMENTS BY ID***********************************************************/
function AlbById(sourceobj,fileId) {
	var targetobj, page, url;
	if (fileId.length > 0) {
		readPageValues();
		page = 'SummaryAlbum.html';
		targetobj = 'album';
		url = page + '?source=library&mediatype=audio&searchtype=fileId&sourceobj='+ sourceobj +'&targetobj='+ targetobj +'&resulttype=grouped&value='+ fileId +'&searchformula=' + this.searchformula;
		callUrl(url);
	}
} 
function filesById(sourceobj,fileId, usePlayingNowValues) {
//	search files by Id
	var page, mediatype, targetobj, searchformula, divAttr, url;
	page = ''; 
	targetobj = 'files';
	searchformula = '';
	mediatype = 'audio'; //toDo
	
	if (fileId.length > 0) {
	//	readPageValues();

	//	if(usePlayingNowValues){
	//		mediatype = this.curMediaType;
	//	} else {
	//		mediatype = readMediaType();
	//	}

		if (mediatype == 'image') {
			page ='ImageFiles.html'; 
			
		}else if (mediatype == 'video') {
			page = 'VideoFiles.html'; 

		}else if (mediatype == 'audio') {
			page = 'AudioFiles.html'; 

			if (sourceobj == 'album' || sourceobj == 'genrealbum') {
				page = 'AudioFiles_trackNr.html';
				
				if (sourceobj == 'genrealbum') {
				// get searchformula to get genre files
					sourceobj = 'album';
					divAttr = $('divAttrAudioGenreAlbum');
				}else{
					divAttr = $('divAttrAlbum');
				}
				try{
					if (divAttr) {
						searchformula = divAttr.getAttribute('searchformula');						
					}
				}catch(ex) {}
			}
		}else{
			page = 'OtherFiles.html'; 
		}
		url = page + '?source=library&mediatype=' + mediatype + '&searchtype=fileId&sourceobj='+ sourceobj +'&targetobj='+targetobj+'&value='+fileId+'&searchformula='+searchformula;

		callUrl(url);
	}
} 
function ArtByGen(sourceobj,fileId) {
//search files by Id
	if (fileId.length > 0) {
		var page = 'SummaryArtist.html';
		var targetobj = 'artist';

		var url = page + '?source=library&mediatype=audio&searchtype=fileId&sourceobj='+ sourceobj +'&targetobj='+targetobj+'&value='+fileId;
		callUrl(url);
	}
} 
function AlbByArt(sourceobj,fileId) {
//search files by Id
	if (fileId.length > 0) {
		var page = 'Album.html';
		var targetobj = 'album';

		var url = page + '?source=library&mediatype=audio&searchtype=fileId&sourceobj='+ sourceobj +'&targetobj='+targetobj+'&value='+fileId;
		callUrl(url);
	}
} 
function noBubble(e) {
//	Special section to prevent bubbling
// 	normally not needed 
// 	only a must use when a link in link is used
// 	like <div onclick='test1.....<div onclick='test2.....</div></div>
// 	see here for more informations http://www.quirksmode.org/js/events_order.html
	if (!e) {
		e = window.event;
	}
	if (e.stopPropagation) {
		e.stopPropagation();
	} else {
		e.cancelBubble = true;
	}
}
function PlaylistFilesById(e,mediatype,playlistId) {
//	files by Playlist
	noBubble(e);

	if (playlistId.length > 0) {
		var url = 'Files.html?source=playlist&mediatype=' + mediatype + '&searchtype=playlistId&sourceobj=playlist&targetobj=file&value=' + playlistId;
		if (typeof(maxitems) == 'number') {
			url = url + '&showmaxitems=' + maxitems;
		}
		callUrl(url);
	}
} 
function PlaylistByGroupId(e,mediatype, value) {
//	Playlist by PlaylistGroup
	noBubble(e);

	if (value.length > 0) {
		var url = 'Playlists.html?source=playlist&mediatype=' + mediatype + '&searchtype=playlistGroupId&value=' + value;
		callUrl(url);
	}
} 
/***********************************ELEMENTS BY GENRE***********************************************************/
function ArtByGenId(fileId) {
//	search Artist by GenreId
	if (fileId.length > 0) {
		var url = 'SummaryAudioGenreArtist.html?source=library&mediatype=audio&searchtype=fileId&sourceobj=genre&targetobj=artist&value=' + fileId;
		callUrl(url);
	}
} 
function AlbByGenId(fileId) {
//	search Album by GenreId
	if (fileId.length > 0) {
		var url = 'SummaryAudioGenreAlbum.html?source=library&mediatype=audio&searchtype=fileId&sourceobj=genre&targetobj=album&value=' + fileId;
		if (typeof(maxitems) == 'number') {
			url = url + '&showmaxitems=' + maxitems;
		}
		callUrl(url,true);
	}
} 
function ArtAlbByGenId(fileId) {
//	search Artist by GenreId
	if (fileId.length > 0) {
		var url = 'SummaryAudioGenreAlbumArtist.html?source=library&mediatype=audio&searchtype=fileId&sourceobj=genre&targetobj=album artist (auto)&value=' + fileId;
		callUrl(url);
	}
} 
 function GenreFlow(fileId) {
//	show Artist/Album/Files or Files
// 	0 = files
// 	1 or 2 = Artist or Artist/Album
// 	3 = Album
	if (GenrePageFlow == '0') {
		filesById('genre',fileId);
	}else if (GenrePageFlow == '3') {
		AlbByGenId(fileId);
	}else{	
		ArtByGenId(fileId);
	}
}
function AlbOrFileByArtId(fileId) {
//	search Album by Id and Genre
	if (fileId.length > 0) {
		var url = '';
		var divAttr = $('divAttrAudioGenreArtist');
		var searchformula = '';
			
		try{
			if (divAttr) {
				searchformula = divAttr.getAttribute('searchformula');
			}
		}catch(ex) {}
		if (GenrePageFlow == '1') {
			// show files
			url = 'SummaryName.html?source=library&mediatype=audio&searchtype=fileId&sourceobj=artist&targetobj=files&value='+ fileId +'&searchformula=' + searchformula;
		}else{
			// show Album
			url = 'SummaryAudioGenreAlbum.html?source=library&mediatype=audio&searchtype=fileId&sourceobj=artist&targetobj=album&resulttype=grouped&value='+ fileId +'&searchformula=' + searchformula;
		}
	
		callUrl(url);
	}
} 

/***********************************INIT***********************************************************/
function getInitialValues() {
	command('initvalues', '', '', false); //false = FF importend, sonst wirf Browser title beim 1.Start nicht aktualisiert
}
/***********************************PLAYING NOW /ADD & DEL***************************************************/
function addById(e,mediatype, sourceobj, value, showDialog, addType) {
//play a file by Id
	noBubble(e);
	
	if (addType !== 'true' && addType !== 'false') {
		addType='';
	}
	if (showDialog == 'true') {
		iui.showAddpanel(sourceobj, value);
	}else{
		readPageValues();
		var url = '';
		if (sourceobj == 'searchfiles') {
			url = 'control.cgi?command=addById&source=' + this.source + '&mediatype=' + this.mediatype +'&searchtype=' + this.searchtype +'&sourceobj='+ this.sourceobj + '&value='+this.searchvalue + '&subvalue='+this.subvalue + '&sort='+this.sort;
		}else{
			url = 'control.cgi?command=addById&source=' + this.source + '&searchtype=fileid&sourceobj='+ sourceobj + '&value=' + value + '&subvalue=' + addType;
		}
		command('addById', url,'');
	}
}
function playById(e,mediatype, sourceobj, value, showDialog, addType) {
//	play a file by Id
	noBubble(e);

	if (addType !== 'true') {
		addType = '';
	}
	if (showDialog == 'true') {
		iui.showAddpanel(sourceobj, value);
	} else {
		readPageValues();
		var url = 'control.cgi?command=playById&source=' + this.source  + '&mediatype=' + this.mediatype + '&searchtype=fileid&sourceobj='+ sourceobj + '&value=' + value + '&subvalue=' + addType;
		command('playById', url,'');
	}
}	
function reshufflePn() {
//	reshuffle playing now
	command('reshufflePlayingNow', '', '',true);
}
function sortyByArtistPn() {
//	sort playing now by Artist
//	command('sortByArtistPlayingNow','','',true);
	var showPage, url, subUrl;
	readPageValues();
	showPage = this.curPageTmp;
	subUrl = 'source=playingnow&mediatype=searchtype=&showmaxitems=' + this.showmaxitems + '&sort=Artist';
	url = 'Queue.html?' + subUrl + '&showpage=1';

	url = encodeURI(url);
	callUrl(url);
}
function recallPage(pageAction) {
	var showPage, url, subUrl;
	readPageValues();
	showPage = this.curPageTmp;
	subUrl = 'source=' + this.source + '&mediatype=' + this.mediatype + '&searchtype=' + this.searchtype + '&sourceobj=' + this.sourceobj + '&targetobj=' + this.targetobj + '&value=' + this.searchvalue + '&showmaxitems=' + this.showmaxitems + '&sort=' + this.sort + '&subvalue=' + this.subvalue;
	url = this.page+'?' + subUrl + '&showpage=' + showPage;

	url = encodeURI(url);
	callUrl(url);
}
function delFilPnPos(e,mediatype,value) {
//	delete File from playingnow by position
	noBubble(e);
	readPageValues();

	if (value.length > 0) {
		this.curPageTmp = this.curPage;
		var	url = 'control.cgi?command=delFileFromPlayingNowByPos&source=' + this.source + '&mediatype=' + mediatype + '&sourceobj=' + sourceobj + '&searchtype=fileid&value=' + value;
		command('delFileFromPlayingNowByPos', url,'', true);
		recallPage();
	}
}
function delPn() {
//	delete all files from playing now
	command('delPlayingNow','','',true);
}

function smartlistRefresh() {
	readPageValues();
	var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj+'&value='+ this.searchvalue +'&sort='+ this.sort +'&subvalue='+ this.subvalue+'&searchformula='+this.searchformula;
	var url = 'control.cgi?command=smartlistrefresh&' + subUrl;
	command('SmartlistRefresh', url, '', true);
	recallPage();
}
/****************************************COVER***********************************************************/
function getCoverById(fileId) {
//	gets cover by fileID
	var curloc = window.location.pathname;
	try{
		if (document.artwork_img) {
			if (document.artwork_img.src) {
				document.artwork_img.src = 'control.cgi?command=getCoverById&value=' + fileId + '&subvalue=small&location=' + curloc ;
			}
		}
	}catch(a) {}
}
function getCoverByPos(pos) {
//	gets cover by filePosition
	var curloc = window.location.pathname;
	try{
	if (document.artwork_img) {
		if (document.artwork_img.src) {
			document.artwork_img.src = 'control.cgi?command=getCoverByPos&value=' + pos + '&subvalue=small&location=' + curloc ;
		}
		}
	}catch(ax) {}
}
/***********************************PLAYER/PLAY***********************************************************/
function getPlayerState() {
//	get player status
	command('playerstate');
}
function playOrAdd(e,mediatype, sourceobj, value) {
//	play a file by Id
	noBubble(e);
	readPageValues();
	var	url = 'control.cgi?command=playOrAdd&source=' + this.source + '&mediatype=' + mediatype + '&sourceobj='+ sourceobj + '&searchtype=fileid&value=' + value;
	command('playOrAdd', url,'');
}
function plToggle(fileId) {
// playtoggle 
	if (fileId.length > 0) {
		command('playtoggle', fileId);
	}
}
function plByPos(pos) {
// play file by position (playing now)
	if (pos.length > 0) {
		command('playFileByPos', pos);
	}
}
function plSearchFiles() {
//play all searched files
// vars are stored in html
	readPageValues();
	var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj='+ this.targetobj +'&value='+ this.searchvalue +'&showmaxitems='+this.showmaxitems +'&sort='+ this.sort +'&subvalue='+ this.subvalue+'&searchformula=' + this.searchformula;

	var url = 'control.cgi?command=playSearchFiles&' + subUrl;
	command('playSearchFiles', url,'');
}
function addSearchFiles() {
//add all searched files
	readPageValues();
	var subUrl = 'source=' + this.source + '&mediatype='+ this.mediatype +'&searchtype='+ this.searchtype +'&sourceobj='+ this.sourceobj +'&targetobj=' + this.targetobj + '&value=' + this.searchvalue +'&showmaxitems='+this.showmaxitems +'&sort='+ this.sort +'&subvalue='+ this.subvalue+'&searchformula='+this.searchformula;
	var url = 'control.cgi?command=addSearchFiles&' + subUrl;
	command('addSearchFiles', url,'');
}
/******************************************EXTRAS***********************************************************/
function spec(e, command, value, sourceobj, showDialog, action, frameName) {
//Special section to prevent bubbling
// normally not needed 
// only a must use when a link in link is used
// like <div onclick='test1.....<div onclick='test2.....</div></div>
// see here for more informations http://www.quirksmode.org/js/events_order.html
	if (!e) {
		e = window.event;
	}
	if (e.stopPropagation) {
		e.stopPropagation();
	} else {
		e.cancelBubble = true;
	}

	if (executeCallUrl) {
		if (command=='addById') {
			addById(value, sourceobj, showDialog);	
		}else if (command=='playById') {
			playById(value, sourceobj, showDialog);	
		}else if (command == 'plByPos') {
			plByPos(value);
//			}else if (command == 'AlbGrpByArt') {
//				AlbGrpByArt(value);	
		}else if (command == 'setActiveZone') {
			setActiveZone(value);	
//		}else if (command=='PlById') {
//			PlById(value);		
//		}else if (command=='PlaylistByGroupId') {
	//		PlaylistByGroupId(value);
//		}else if (command=='delFilPnPos') {
//			delFilPnPos(value);	
		}else if (command == 'syncZones') {
			syncZones(value);
		}else if (command == 'syncAllZones') {
			syncAllZones(value);
		}else if (command == 'zoneVoldown') {
			zoneVoldown(value);
		}else if (command == 'zoneMuteToggle') {
			zoneMuteToggle(value);
		}else if (command == 'zoneVolup') {
			zoneVolup(value);		
		}else if (command == 'dummy') {
			return false;
		}else{
			alert('No Special command: ' + command);
			return false;
		}
	}
}	
function jumpToAnker(anker) {
	window.location.href = anker;
}
function saveTags(fileID) {
	var continueFlag = true;
	// auch hier encodeURIComponent wichtig, da sonst bei '&' in Title zu Problemen
	// kommt... auch wenn unten nochmal encodeURIComponent benutzt wird
	var ArtistTxt = encodeURIComponent($('idArtist').value);
	var TitleTxt = encodeURIComponent($('idTitle').value);
	var GenreTxt = encodeURIComponent($('idGenre').value);
	var AlbumTxt = encodeURIComponent($('idAlbum').value);
	var YearTxt = encodeURIComponent($('idYear').value);
	var TrackNr = encodeURIComponent($('idTrackNr').value);

	if (!form_input_is_numeric(TrackNr)) {
		updateMsgText('page', 'error','error');
		continueFlag = false;
	} 
	if (continueFlag) {
		if (!form_input_is_numeric(YearTxt)) {
			updateMsgText('page', 'error','error');
			continueFlag = false;
		} 
	}
	
	var json = '"artist":"' + ArtistTxt +'","name":"'+ TitleTxt +'","genre":"'+ GenreTxt +'","album":"'+ AlbumTxt + '","year":"'+ YearTxt + '","tracknumber":"'+ TrackNr + '"'; 

	json = encodeURIComponent(json);
	if (continueFlag) {
		command('saveTags', fileID, json, false);
	}
	
}

/**************************************events******************************************/
if (document.attachEvent) {
//ie
	document.attachEvent('onkeydown', focusSearchField, true);
	document.attachEvent('onmousewheel', mousewheelPage, false);
} else if (document.addEventListener) {
//safari,ff, Chrome
	document.addEventListener('keydown', focusSearchField, true);
	var mousewheelevt = (/Firefox/i.test(navigator.userAgent))? "DOMMouseScroll" : "mousewheel" //FF doesn't recognize mousewheel as of FF3.x
	document.addEventListener (mousewheelevt, mousewheelPage, false);
} else {
	window.addEventListener('keydown', focusSearchField, true);
	window.addEventListener('mousewheel', mousewheelPage, false);

}