﻿// Delegate for the settings closing event. 
System.Gadget.onSettingsClosing = SettingsClosing;

function LoadSettings(){
    var tmpAddress = System.Gadget.Settings.readString('IPADDRESS');
    var tmpPort = System.Gadget.Settings.readString('PORT');
    var tmpDefaultPage = System.Gadget.Settings.readString('DEFAULTPAGE');
	
    if (String(tmpAddress) !== '')
    {
        IPADDRESS.value = tmpAddress;
    }
	if (String(tmpPort) !== '')
    {
        PORT.value = tmpPort;
    }
	if (String(tmpDefaultPage) !== '')
    {
        DEFAULTPAGE.value = tmpDefaultPage;
    }else{
		DEFAULTPAGE.value = 'Imported';
	}
	var defPage = DEFAULTPAGE.value;
    IPADDRESS.select();
}

function $(id){ return document.getElementById(id); }

function SettingsClosing(event){
    // User hit OK on the settings page.
    if (event.closeAction == event.Action.commit) {
		var ipCheckOK = false;
		var ipPortCheckOK = false;

		if (IPADDRESS.value !== ''){
			if (checkIpAddress(IPADDRESS.value)){
				ipCheckOK = true;
			}
		}
		if (PORT.value !== ''){
			if (checkIpPort(PORT.value)){
				ipPortCheckOK = true;
			}
		}

		if (ipCheckOK && ipPortCheckOK){
            System.Gadget.Settings.writeString('IPADDRESS', IPADDRESS.value);
			System.Gadget.Settings.writeString('PORT', PORT.value);
			System.Gadget.Settings.writeString('DEFAULTPAGE', DEFAULTPAGE.value);
			
			var xpTunesURL = 'http://' + IPADDRESS.value + ':' + PORT.value +'/';
			
			System.Gadget.Settings.writeString('XPTUNESURL', xpTunesURL);
            // Allow the Settings dialog to close.
			event.cancel = false;
        }else{
			if (!ipCheckOK){
				IPADDRESS.focus();
				writeSetting('Please enter valid ip address');
			}else{
				PORT.select();
				writeSetting('Please enter valid port');
			}
			// No user entry and 'Ok' invoked, cancel the Settings closing event.
			if (event.cancellable===false){
				event.cancel = true;
			}
        }
    }
}
function checkIpAddress(ipAdress){
	var filter = /^(([1-9][0-9]{0,2})|0)\.(([1-9][0-9]{0,2})|0)\.(([1-9][0-9]{0,2})|0)\.(([1-9][0-9]{0,2})|0)$/;
	if (!filter.test(ipAdress)) {
		return false;
	}else{
		return true;
	}
}
function checkIpPort(port){
	var filter = /^(([1-9][0-9]{0,3})|0)$/;
	if (!filter.test(port)) {
		return false;
	}else{
		return true;
	}
}
function writeSetting(text){
	var msg_text = $('msgText');
	if(msg_text){
		msg_text.innerHTML = text;
	}
}
function commandCallback(jsonArr) {	
//callback from xpTunes Server
	var jsonObjArr = eval('(' + jsonArr + ')');	

	for (var x = 0; x < jsonObjArr.length; x+=1) {
		started = true;
		try{
			var responseTyp = jsonObjArr[x].response;
			var val = jsonObjArr[x].value;

			if(responseTyp =='loginseed') {
				writeSetting('Test OK');
			}else{
				writeSetting('Test Nok');
			}
		}catch(c){}
	}
}		
function command(action, xpTunesUrl) {
// 	sends a synchron/asynchron command to xpTunes server
//	request
	var requestTimer;
	var url = '';
	http_request = false;
	/* prevent cache with new Date().valueOf() */
	url = xpTunesUrl + 'control.cgi?command=' + action + '&preventCache=' + new Date().valueOf();	
	
	 if (window.XMLHttpRequest) { // Mozilla,  Safari, IE7...
		http_request = new XMLHttpRequest();
        if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
        }
    }else if (window.ActiveXObject) { // IE6
        try {
            http_request = new ActiveXObject('Msxml2.XMLHTTP');
        }catch (e){
			try {
				http_request = new ActiveXObject('Microsoft.XMLHTTP');
            } catch (c) {}
        }
    } 

    var ret;
	
	requestTimer = setTimeout(function() { writeSetting('Test NOT ok'); requestTimer=0;}, 5000);
	
	if (http_request) {
		http_request.onreadystatechange = function (){
			if (http_request.readyState == 4) {
				if (http_request.status == 200) {
					if(requestTimer){
						clearTimeout(requestTimer);
						requestTimer=0;
					}
					var ret = commandCallback(http_request.responseText);
					return ret;
				}
			}
		};
		
		http_request.open('GET', url, true);
		writeSetting('wait for response');
	}
	http_request.send(null);
    return ret;
}
function testConnection(){
	var xpTunesURL;
	var ipCheckOK = false;
	var ipPortCheckOK = false;
		
	if (IPADDRESS.value !== ''){
		if (checkIpAddress(IPADDRESS.value)){
			ipCheckOK = true;
		}
	}
	if (PORT.value !== ''){
		if (checkIpPort(PORT.value)){
			ipPortCheckOK = true;
		}
	}

	if (ipCheckOK && ipPortCheckOK){
		writeSetting('sending test message');
		xpTunesURL = 'http://' + IPADDRESS.value + ':' + PORT.value +'/';
		command('getsid2',xpTunesURL);
	}else{
		if (!ipCheckOK){
			writeSetting('Please enter valid ip address');
		}else{
			writeSetting('Please enter valid port');
        }
	}
}

